#include "FecFacetDrawerGL.hxx"
/* Generated by GIWS (version 1.0.6) */
/*

Copyright 2007-2008 INRIA

Author : Sylvestre Ledru & others

This software is a computer program whose purpose is to hide the complexity
of accessing Java objects/methods from C++ code.

This software is governed by the CeCILL-B license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL-B
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL-B license and that you accept its terms.
*/

namespace org_scilab_modules_renderer_fecDrawing {

// Returns the current env

JNIEnv * FecFacetDrawerGL::getCurrentEnv() {
JNIEnv * curEnv = NULL;
this->jvm->AttachCurrentThread(reinterpret_cast<void **>(&curEnv), NULL);
return curEnv;
}
// Destructor

FecFacetDrawerGL::~FecFacetDrawerGL() {
JNIEnv * curEnv = NULL;
this->jvm->AttachCurrentThread(reinterpret_cast<void **>(&curEnv), NULL);

curEnv->DeleteGlobalRef(this->instance);
curEnv->DeleteGlobalRef(this->instanceClass);
}
// Constructors

FecFacetDrawerGL::FecFacetDrawerGL(JavaVM * jvm_) {
jmethodID constructObject = NULL ;
jobject localInstance ;
jclass localClass ;
const std::string construct="<init>";
const std::string param="()V";
jvm=jvm_;

JNIEnv * curEnv = getCurrentEnv();

localClass = curEnv->FindClass( this->className().c_str() ) ;
if (localClass == NULL) {
  throw GiwsException::JniClassNotFoundException(curEnv, this->className());
}

this->instanceClass = static_cast<jclass>(curEnv->NewGlobalRef(localClass));

/* localClass is not needed anymore */
curEnv->DeleteLocalRef(localClass);

if (this->instanceClass == NULL) {
throw GiwsException::JniObjectCreationException(curEnv, this->className());
}


constructObject = curEnv->GetMethodID( this->instanceClass, construct.c_str() , param.c_str() ) ;
if(constructObject == NULL){
throw GiwsException::JniObjectCreationException(curEnv, this->className());
}

localInstance = curEnv->NewObject( this->instanceClass, constructObject ) ;
if(localInstance == NULL){
throw GiwsException::JniObjectCreationException(curEnv, this->className());
}
 
this->instance = curEnv->NewGlobalRef(localInstance) ;
if(this->instance == NULL){
throw GiwsException::JniObjectCreationException(curEnv, this->className());
}
/* localInstance not needed anymore */
curEnv->DeleteLocalRef(localInstance);

                /* Methods ID set to NULL */
voiddisplayID=NULL; 
voidinitializeDrawingjintID=NULL; 
voidendDrawingID=NULL; 
voidshowjintID=NULL; 
voiddestroyjintID=NULL; 
voidsetFacetParametersjdoublejdoublejintjintjintjintID=NULL; 
voiddrawFecjdoubleArrayjdoubleArrayjdoubleArrayjintArrayjintArrayjintArrayID=NULL; 


}

FecFacetDrawerGL::FecFacetDrawerGL(JavaVM * jvm_, jobject JObj) {
        jvm=jvm_;

        JNIEnv * curEnv = getCurrentEnv();

jclass localClass = curEnv->GetObjectClass(JObj);
        this->instanceClass = static_cast<jclass>(curEnv->NewGlobalRef(localClass));
        curEnv->DeleteLocalRef(localClass);

        if (this->instanceClass == NULL) {
throw GiwsException::JniObjectCreationException(curEnv, this->className());
        }

        this->instance = curEnv->NewGlobalRef(JObj) ;
        if(this->instance == NULL){
throw GiwsException::JniObjectCreationException(curEnv, this->className());
        }
        /* Methods ID set to NULL */
        voiddisplayID=NULL; 
voidinitializeDrawingjintID=NULL; 
voidendDrawingID=NULL; 
voidshowjintID=NULL; 
voiddestroyjintID=NULL; 
voidsetFacetParametersjdoublejdoublejintjintjintjintID=NULL; 
voiddrawFecjdoubleArrayjdoubleArrayjdoubleArrayjintArrayjintArrayjintArrayID=NULL; 


}

// Generic methods

void FecFacetDrawerGL::synchronize() {
if (getCurrentEnv()->MonitorEnter(instance) != JNI_OK) {
throw GiwsException::JniMonitorException(getCurrentEnv(), "FecFacetDrawerGL");
}
}

void FecFacetDrawerGL::endSynchronize() {
if ( getCurrentEnv()->MonitorExit(instance) != JNI_OK) {
throw GiwsException::JniMonitorException(getCurrentEnv(), "FecFacetDrawerGL");
}
}
// Method(s)

void FecFacetDrawerGL::display (){

JNIEnv * curEnv = getCurrentEnv();

if (voiddisplayID==NULL) { /* Use the cache Luke */ voiddisplayID = curEnv->GetMethodID(this->instanceClass, "display", "()V" ) ;
if (voiddisplayID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "display");
}
}
                         curEnv->CallVoidMethod( this->instance, voiddisplayID );if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void FecFacetDrawerGL::initializeDrawing (int figureIndex){

JNIEnv * curEnv = getCurrentEnv();

if (voidinitializeDrawingjintID==NULL) { /* Use the cache Luke */ voidinitializeDrawingjintID = curEnv->GetMethodID(this->instanceClass, "initializeDrawing", "(I)V" ) ;
if (voidinitializeDrawingjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "initializeDrawing");
}
}
                         curEnv->CallVoidMethod( this->instance, voidinitializeDrawingjintID ,figureIndex);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void FecFacetDrawerGL::endDrawing (){

JNIEnv * curEnv = getCurrentEnv();

if (voidendDrawingID==NULL) { /* Use the cache Luke */ voidendDrawingID = curEnv->GetMethodID(this->instanceClass, "endDrawing", "()V" ) ;
if (voidendDrawingID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "endDrawing");
}
}
                         curEnv->CallVoidMethod( this->instance, voidendDrawingID );if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void FecFacetDrawerGL::show (int figureIndex){

JNIEnv * curEnv = getCurrentEnv();

if (voidshowjintID==NULL) { /* Use the cache Luke */ voidshowjintID = curEnv->GetMethodID(this->instanceClass, "show", "(I)V" ) ;
if (voidshowjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "show");
}
}
                         curEnv->CallVoidMethod( this->instance, voidshowjintID ,figureIndex);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void FecFacetDrawerGL::destroy (int parentFigureIndex){

JNIEnv * curEnv = getCurrentEnv();

if (voiddestroyjintID==NULL) { /* Use the cache Luke */ voiddestroyjintID = curEnv->GetMethodID(this->instanceClass, "destroy", "(I)V" ) ;
if (voiddestroyjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "destroy");
}
}
                         curEnv->CallVoidMethod( this->instance, voiddestroyjintID ,parentFigureIndex);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void FecFacetDrawerGL::setFacetParameters (double zMin, double zMax, int colMin, int colMax, int colOutLow, int colOutUp){

JNIEnv * curEnv = getCurrentEnv();

if (voidsetFacetParametersjdoublejdoublejintjintjintjintID==NULL) { /* Use the cache Luke */ voidsetFacetParametersjdoublejdoublejintjintjintjintID = curEnv->GetMethodID(this->instanceClass, "setFacetParameters", "(DDIIII)V" ) ;
if (voidsetFacetParametersjdoublejdoublejintjintjintjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "setFacetParameters");
}
}
                         curEnv->CallVoidMethod( this->instance, voidsetFacetParametersjdoublejdoublejintjintjintjintID ,zMin, zMax, colMin, colMax, colOutLow, colOutUp);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void FecFacetDrawerGL::drawFec (double * xCoords, int xCoordsSize, double * yCoords, int yCoordsSize, double * values, int valuesSize, int * fristPoints, int fristPointsSize, int * secondPoints, int secondPointsSize, int * thirdPoints, int thirdPointsSize){

JNIEnv * curEnv = getCurrentEnv();

if (voiddrawFecjdoubleArrayjdoubleArrayjdoubleArrayjintArrayjintArrayjintArrayID==NULL) { /* Use the cache Luke */ voiddrawFecjdoubleArrayjdoubleArrayjdoubleArrayjintArrayjintArrayjintArrayID = curEnv->GetMethodID(this->instanceClass, "drawFec", "([D[D[D[I[I[I)V" ) ;
if (voiddrawFecjdoubleArrayjdoubleArrayjdoubleArrayjintArrayjintArrayjintArrayID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "drawFec");
}
}
jdoubleArray xCoords_ = curEnv->NewDoubleArray( xCoordsSize ) ;

if (xCoords_ == NULL)
{
// check that allocation succeed
throw GiwsException::JniBadAllocException(curEnv);
}

curEnv->SetDoubleArrayRegion( xCoords_, 0, xCoordsSize, (jdouble*)(xCoords) ) ;


jdoubleArray yCoords_ = curEnv->NewDoubleArray( yCoordsSize ) ;

if (yCoords_ == NULL)
{
// check that allocation succeed
throw GiwsException::JniBadAllocException(curEnv);
}

curEnv->SetDoubleArrayRegion( yCoords_, 0, yCoordsSize, (jdouble*)(yCoords) ) ;


jdoubleArray values_ = curEnv->NewDoubleArray( valuesSize ) ;

if (values_ == NULL)
{
// check that allocation succeed
throw GiwsException::JniBadAllocException(curEnv);
}

curEnv->SetDoubleArrayRegion( values_, 0, valuesSize, (jdouble*)(values) ) ;


jintArray fristPoints_ = curEnv->NewIntArray( fristPointsSize ) ;

if (fristPoints_ == NULL)
{
// check that allocation succeed
throw GiwsException::JniBadAllocException(curEnv);
}

curEnv->SetIntArrayRegion( fristPoints_, 0, fristPointsSize, (jint*)(fristPoints) ) ;


jintArray secondPoints_ = curEnv->NewIntArray( secondPointsSize ) ;

if (secondPoints_ == NULL)
{
// check that allocation succeed
throw GiwsException::JniBadAllocException(curEnv);
}

curEnv->SetIntArrayRegion( secondPoints_, 0, secondPointsSize, (jint*)(secondPoints) ) ;


jintArray thirdPoints_ = curEnv->NewIntArray( thirdPointsSize ) ;

if (thirdPoints_ == NULL)
{
// check that allocation succeed
throw GiwsException::JniBadAllocException(curEnv);
}

curEnv->SetIntArrayRegion( thirdPoints_, 0, thirdPointsSize, (jint*)(thirdPoints) ) ;


                         curEnv->CallVoidMethod( this->instance, voiddrawFecjdoubleArrayjdoubleArrayjdoubleArrayjintArrayjintArrayjintArrayID ,xCoords_, yCoords_, values_, fristPoints_, secondPoints_, thirdPoints_);curEnv->DeleteLocalRef(xCoords_);
curEnv->DeleteLocalRef(yCoords_);
curEnv->DeleteLocalRef(values_);
curEnv->DeleteLocalRef(fristPoints_);
curEnv->DeleteLocalRef(secondPoints_);
curEnv->DeleteLocalRef(thirdPoints_);
if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

}
